/*----- PROTECTED REGION ID(Agilent33500B.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        Agilent33500B.cpp
//
// description : C++ source for the Agilent33500B class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Agilent33500B are implemented in this file.
//
// project :     Agilent33500B
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

// #include <Agilent33500B.h>
#include "Agilent33500BClass.h"
#include <math.h>
#include <iostream>
#include <iomanip>
#include <sys/types.h>
#include <sys/stat.h>
#include "LoadThread.h"

#ifdef USE_YAT4TANGO
#include <yat4tango/DeviceInfo.h>
#include <yat4tango/Logging.h>
#include <yat/Portability.h>        //- NaN
#include <yat4tango/PropertyHelper.h>
#endif

// static double NaN = ::sqrt(-1);

/*----- PROTECTED REGION END -----*/	//	Agilent33500B.cpp

/**
 *  Agilent33500B class description:
 *    A class to control the Agilent 33500B waveform generator
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name              |  Method name
//================================================================
//  State                     |  dev_state
//  Status                    |  Inherited (no method)
//  Reset                     |  reset
//  On                        |  on
//  Off                       |  off
//  LoadConfigurationFile     |  load_configuration_file
//  SaveConfigurationFile     |  save_configuration_file
//  GetConfigurationFilePath  |  get_configuration_file_path
//  SaveToFlash               |  save_to_flash
//  ReLoadConfigurationFile   |  re_load_configuration_file
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  Impedance           |  Tango::DevDouble	Scalar
//  Amplitude           |  Tango::DevDouble	Scalar
//  Offset              |  Tango::DevDouble	Scalar
//  SampleRate          |  Tango::DevDouble	Scalar
//  TriggerMode         |  Tango::DevShort	Scalar
//  Triggering          |  Tango::DevShort	Scalar
//  Delay               |  Tango::DevDouble	Scalar
//  TrackMode           |  Tango::DevShort	Scalar
//  BurstMode           |  Tango::DevShort	Scalar
//  BurstCycle          |  Tango::DevShort	Scalar
//  BurstState          |  Tango::DevShort	Scalar
//  HighVoltage         |  Tango::DevDouble	Scalar
//  LowVoltage          |  Tango::DevDouble	Scalar
//  Configuration_File  |  Tango::DevString	Scalar
//  Function            |  Tango::DevShort	Scalar
//  Frequency           |  Tango::DevDouble	Scalar
//  NoiseBandwidth      |  Tango::DevDouble	Scalar
//  OutputMode          |  Tango::DevShort	Scalar
//  WaveformFilter      |  Tango::DevShort	Scalar
//  Waveform            |  Tango::DevDouble	Spectrum  ( max = 16000000)
//================================================================

namespace Agilent33500B_ns
{
/*----- PROTECTED REGION ID(Agilent33500B::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Agilent33500B::namespace_starting

//--------------------------------------------------------
/**
 *	Method     : Agilent33500B::Agilent33500B()
 *	Description: Constructors for a Tango device
 *                implementing the classAgilent33500B
 */
//--------------------------------------------------------
Agilent33500B::Agilent33500B(Tango::DeviceClass *cl, std::string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Agilent33500B::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::constructor_1
}
//--------------------------------------------------------
Agilent33500B::Agilent33500B(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Agilent33500B::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::constructor_2
}
//--------------------------------------------------------
Agilent33500B::Agilent33500B(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Agilent33500B::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::constructor_3
}
//--------------------------------------------------------
Agilent33500B::~Agilent33500B()
{
	delete_device();
}

//--------------------------------------------------------
/**
 *	Method     : Agilent33500B::delete_device()
 *	Description: will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Agilent33500B::delete_device()
{
	DEBUG_STREAM << "Agilent33500B::delete_device() " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	if(scpi)
	{
		delete scpi;
		scpi = 0;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::delete_device
	delete[] attr_Impedance_read;
	delete[] attr_Amplitude_read;
	delete[] attr_Offset_read;
	delete[] attr_SampleRate_read;
	delete[] attr_TriggerMode_read;
	delete[] attr_Triggering_read;
	delete[] attr_Delay_read;
	delete[] attr_TrackMode_read;
	delete[] attr_BurstMode_read;
	delete[] attr_BurstCycle_read;
	delete[] attr_BurstState_read;
	delete[] attr_HighVoltage_read;
	delete[] attr_LowVoltage_read;
	delete[] attr_Configuration_File_read;
	delete[] attr_Function_read;
	delete[] attr_Frequency_read;
	delete[] attr_NoiseBandwidth_read;
	delete[] attr_OutputMode_read;
	delete[] attr_WaveformFilter_read;
	delete[] attr_Waveform_read;
}

//--------------------------------------------------------
/**
 *	Method     : Agilent33500B::init_device()
 *	Description: will be called at device initialization.
 */
//--------------------------------------------------------
void Agilent33500B::init_device()
{
	DEBUG_STREAM << "Agilent33500B::init_device() create device " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	scpi = 0;
	waveFormLgth = 0;
	sequence_running = 0;
	sequence_error.clear();

#ifdef USE_YAT4TANGO
	amplitudeSetpoint = yat::IEEE_NAN;
	offsetSetpoint = yat::IEEE_NAN;
  yat4tango::DeviceInfo::initialize( this, YAT_XSTR(PROJECT_NAME), YAT_XSTR(PROJECT_VERSION) );
  yat4tango::Logging::initialize(this);
#else
  amplitudeSetpoint = NAN;
  offsetSetpoint = NAN;
#endif

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::init_device_before


	//	Get the device properties from database
	get_device_property();

	attr_Impedance_read = new Tango::DevDouble[1];
	attr_Amplitude_read = new Tango::DevDouble[1];
	attr_Offset_read = new Tango::DevDouble[1];
	attr_SampleRate_read = new Tango::DevDouble[1];
	attr_TriggerMode_read = new Tango::DevShort[1];
	attr_Triggering_read = new Tango::DevShort[1];
	attr_Delay_read = new Tango::DevDouble[1];
	attr_TrackMode_read = new Tango::DevShort[1];
	attr_BurstMode_read = new Tango::DevShort[1];
	attr_BurstCycle_read = new Tango::DevShort[1];
	attr_BurstState_read = new Tango::DevShort[1];
	attr_HighVoltage_read = new Tango::DevDouble[1];
	attr_LowVoltage_read = new Tango::DevDouble[1];
	attr_Configuration_File_read = new Tango::DevString[1];
	attr_Function_read = new Tango::DevShort[1];
	attr_Frequency_read = new Tango::DevDouble[1];
	attr_NoiseBandwidth_read = new Tango::DevDouble[1];
	attr_OutputMode_read = new Tango::DevShort[1];
	attr_WaveformFilter_read = new Tango::DevShort[1];
	attr_Waveform_read = new Tango::DevDouble[16000000];
	/*----- PROTECTED REGION ID(Agilent33500B::init_device) ENABLED START -----*/
	
	//	Initialize device
	if( iPAddress.length()==0 ) {
            cerr << "ERROR: IPAddress property not defined" << endl;
  #ifdef EXIT_ON_CONFIGERROR
            exit(0);
  #endif
	}
	if( iPAddress.empty() ) {
            cerr << "ERROR: EMPTY IPAddress property not defined" << endl;
#ifdef EXIT_ON_CONFIGERROR
            exit(0);
#endif
	}
	scpi = new Scpi(iPAddress,output,timeout,saveInternalConfig);
  scpi->HasTrack(trackModeSupport);
	lastUpdate=0;
	waveFormLgth=0;
	set_state(Tango::UNKNOWN);
	set_status("The device is not initialised");
	
	if( !scpi->SetWAI() ) {	
	  cerr << "SetWAI() Warning," << scpi->GetLastError() << endl;
	}
	if( !scpi->SetVPP() ) {	
	  cerr << "SetVPP() Warning," << scpi->GetLastError() << endl;
	}
  if( !scpi->SetLimit(false) ) {
    cerr << "SetLimit() Warning," << scpi->GetLastError() << endl;
  }

  if( !scpi->SetStateRecall() ) {
    cerr << "SetStateRecall() Warning," << scpi->GetLastError() << endl;
  }

  strcpy(config_file,configFile.c_str());

  // Restore config
  // As reloading a wafeform modifie the ampliude, offset, reload only if FUNC_ARB is selected
  Tango::DevShort f = atoi( get_write_value_from_db("Function").c_str() );

  amplitudeSetpoint = atof( get_write_value_from_db("Amplitude").c_str() );;
  offsetSetpoint = atof( get_write_value_from_db("Offset").c_str() );;
  if( f==FUNC_ARB ) {
    reload_waveform();
    // Restore amplitude and offset
    scpi->SetAmplitude(amplitudeSetpoint);
    scpi->SetOffset(offsetSetpoint);
  }


  // default umask  ( -rw-rw-rw- )
  umask( ~(S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH) );

  sequence_running = 0;
  sequence_error = "";

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::init_device
}

//--------------------------------------------------------
/**
 *	Method     : Agilent33500B::get_device_property()
 *	Description: Read database to initialize property data members.
 */
//--------------------------------------------------------
void Agilent33500B::get_device_property()
{
	/*----- PROTECTED REGION ID(Agilent33500B::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	iPAddress = "";
	output = 1;
	timeout = 500;
	waveformFile = "wave.txt";
	configFilePath = "";
	configFile = "";
  trackModeSupport = true;
  saveInternalConfig = false;
		
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("IPAddress"));
	dev_prop.push_back(Tango::DbDatum("Output"));
	dev_prop.push_back(Tango::DbDatum("Timeout"));
	dev_prop.push_back(Tango::DbDatum("WaveformFile"));
	dev_prop.push_back(Tango::DbDatum("ConfigFilePath"));
	dev_prop.push_back(Tango::DbDatum("ConfigFile"));
	dev_prop.push_back(Tango::DbDatum("TrackModeSupport"));
	dev_prop.push_back(Tango::DbDatum("SaveInternalConfig"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);

		//	get instance on Agilent33500BClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Agilent33500BClass	*ds_class =
			(static_cast<Agilent33500BClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize IPAddress from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  iPAddress;
		else {
			//	Try to initialize IPAddress from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  iPAddress;
		}
		//	And try to extract IPAddress value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  iPAddress;

		//	Try to initialize Output from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  output;
		else {
			//	Try to initialize Output from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  output;
		}
		//	And try to extract Output value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  output;

		//	Try to initialize Timeout from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  timeout;
		else {
			//	Try to initialize Timeout from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  timeout;
		}
		//	And try to extract Timeout value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  timeout;

		//	Try to initialize WaveformFile from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  waveformFile;
		else {
			//	Try to initialize WaveformFile from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  waveformFile;
		}
		//	And try to extract WaveformFile value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  waveformFile;

		//	Try to initialize ConfigFilePath from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  configFilePath;
		else {
			//	Try to initialize ConfigFilePath from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  configFilePath;
		}
		//	And try to extract ConfigFilePath value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  configFilePath;

		//	Try to initialize ConfigFile from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  configFile;
		else {
			//	Try to initialize ConfigFile from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  configFile;
		}
		//	And try to extract ConfigFile value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  configFile;

		//	Try to initialize TrackModeSupport from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  trackModeSupport;
		else {
			//	Try to initialize TrackModeSupport from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  trackModeSupport;
		}
		//	And try to extract TrackModeSupport value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  trackModeSupport;

		//	Try to initialize SaveInternalConfig from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  saveInternalConfig;
		else {
			//	Try to initialize SaveInternalConfig from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  saveInternalConfig;
		}
		//	And try to extract SaveInternalConfig value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  saveInternalConfig;

	}

	/*----- PROTECTED REGION ID(Agilent33500B::get_device_property_after) ENABLED START -----*/

#ifdef  USE_YAT4TANGO
	//	Check device property data members init
	yat4tango::PropertyHelper::create_property_if_empty(this, dev_prop,"","IPAddress");
#endif

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::get_device_property_after
}

//--------------------------------------------------------
/**
 *	Method     : Agilent33500B::always_executed_hook()
 *	Description: method always executed before any command is executed
 */
//--------------------------------------------------------
void Agilent33500B::always_executed_hook()
{
	DEBUG_STREAM << "Agilent33500B::always_executed_hook()  " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method     : Agilent33500B::read_attr_hardware()
 *	Description: Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Agilent33500B::read_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "Agilent33500B::read_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method     : Agilent33500B::write_attr_hardware()
 *	Description: Hardware writing for attributes
 */
//--------------------------------------------------------
void Agilent33500B::write_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "Agilent33500B::write_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Impedance related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_Impedance(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_Impedance(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_Impedance) ENABLED START -----*/

	attr.set_value(attr_Impedance_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_Impedance
}
//--------------------------------------------------------
/**
 *	Write attribute Impedance related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_Impedance(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_Impedance(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_Impedance) ENABLED START -----*/
	
	if( !scpi->SetImpedance(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_Impedance");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_Impedance
}
//--------------------------------------------------------
/**
 *	Read attribute Amplitude related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_Amplitude(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_Amplitude(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_Amplitude) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Amplitude_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_Amplitude
}
//--------------------------------------------------------
/**
 *	Write attribute Amplitude related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_Amplitude(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_Amplitude(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_Amplitude) ENABLED START -----*/
  amplitudeSetpoint = w_val;
	if( !scpi->SetAmplitude(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_Amplitude");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_Amplitude
}
//--------------------------------------------------------
/**
 *	Read attribute Offset related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_Offset(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_Offset(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_Offset) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Offset_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_Offset
}
//--------------------------------------------------------
/**
 *	Write attribute Offset related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_Offset(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_Offset(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_Offset) ENABLED START -----*/
	offsetSetpoint = w_val;
	if( !scpi->SetOffset(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_Offset");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_Offset
}
//--------------------------------------------------------
/**
 *	Read attribute SampleRate related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_SampleRate(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_SampleRate(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_SampleRate) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_SampleRate_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_SampleRate
}
//--------------------------------------------------------
/**
 *	Write attribute SampleRate related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_SampleRate(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_SampleRate(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_SampleRate) ENABLED START -----*/
	
	if( !scpi->SetSampleRate(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_SampleRate");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_SampleRate
}
//--------------------------------------------------------
/**
 *	Read attribute TriggerMode related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_TriggerMode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_TriggerMode(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_TriggerMode) ENABLED START -----*/

	if( attr_TriggerMode_read[0]<0 )
	  attr.set_quality(Tango::ATTR_INVALID);
	else
	  attr.set_value(attr_TriggerMode_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_TriggerMode
}
//--------------------------------------------------------
/**
 *	Write attribute TriggerMode related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_TriggerMode(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_TriggerMode(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_TriggerMode) ENABLED START -----*/
	
	if( !scpi->SetTrigMode(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_TriggerMode");	
	}
	lastUpdate=0;

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_TriggerMode
}
//--------------------------------------------------------
/**
 *	Read attribute Triggering related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_Triggering(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_Triggering(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_Triggering) ENABLED START -----*/

	if( attr_Triggering_read[0]<0 )
	  attr.set_quality(Tango::ATTR_INVALID);
	else
	  attr.set_value(attr_Triggering_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_Triggering
}
//--------------------------------------------------------
/**
 *	Write attribute Triggering related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_Triggering(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_Triggering(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_Triggering) ENABLED START -----*/
	
	if( !scpi->SetTrigEdge(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_Triggering");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_Triggering
}
//--------------------------------------------------------
/**
 *	Read attribute Delay related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_Delay(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_Delay(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_Delay) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Delay_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_Delay
}
//--------------------------------------------------------
/**
 *	Write attribute Delay related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_Delay(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_Delay(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_Delay) ENABLED START -----*/
	
	if( !scpi->SetDelay(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_Delay");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_Delay
}
//--------------------------------------------------------
/**
 *	Read attribute TrackMode related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_TrackMode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_TrackMode(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_TrackMode) ENABLED START -----*/
	
	if( attr_TrackMode_read[0]<0 )
	  attr.set_quality(Tango::ATTR_INVALID);
	else
	  attr.set_value(attr_TrackMode_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_TrackMode
}
//--------------------------------------------------------
/**
 *	Write attribute TrackMode related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_TrackMode(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_TrackMode(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_TrackMode) ENABLED START -----*/
	
	if( !scpi->SetTrackMode(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_TrackMode");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_TrackMode
}
//--------------------------------------------------------
/**
 *	Read attribute BurstMode related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_BurstMode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_BurstMode(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_BurstMode) ENABLED START -----*/

	if( attr_BurstMode_read[0]<0 )
	  attr.set_quality(Tango::ATTR_INVALID);
	else
	  attr.set_value(attr_BurstMode_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_BurstMode
}
//--------------------------------------------------------
/**
 *	Write attribute BurstMode related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_BurstMode(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_BurstMode(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_BurstMode) ENABLED START -----*/
	
	if( !scpi->SetBurstMode(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_BurstMode");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_BurstMode
}
//--------------------------------------------------------
/**
 *	Read attribute BurstCycle related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_BurstCycle(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_BurstCycle(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_BurstCycle) ENABLED START -----*/
	
	if( attr_BurstCycle_read[0]<0 )
	  attr.set_quality(Tango::ATTR_INVALID);
	else
	  attr.set_value(attr_BurstCycle_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_BurstCycle
}
//--------------------------------------------------------
/**
 *	Write attribute BurstCycle related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_BurstCycle(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_BurstCycle(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_BurstCycle) ENABLED START -----*/
	
	if( !scpi->SetBurstCycle(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_BurstCycle");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_BurstCycle
}
//--------------------------------------------------------
/**
 *	Read attribute BurstState related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_BurstState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_BurstState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_BurstState) ENABLED START -----*/

	if( attr_BurstState_read[0]<0 )
	  attr.set_quality(Tango::ATTR_INVALID);
	else
	  attr.set_value(attr_BurstState_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_BurstState
}
//--------------------------------------------------------
/**
 *	Write attribute BurstState related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_BurstState(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_BurstState(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_BurstState) ENABLED START -----*/
	
	if( !scpi->SetBurstState(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_BurstState");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_BurstState
}
//--------------------------------------------------------
/**
 *	Read attribute HighVoltage related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_HighVoltage(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_HighVoltage(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_HighVoltage) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_HighVoltage_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_HighVoltage
}
//--------------------------------------------------------
/**
 *	Write attribute HighVoltage related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_HighVoltage(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_HighVoltage(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_HighVoltage) ENABLED START -----*/
	
	double newAmp;
	double newOff;
	
	if( !scpi->SetHighVoltage(w_val,&newAmp,&newOff) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_HighVoltage");	
	}
	lastUpdate=0;
	
	update_attr("Amplitude",newAmp);
	update_attr("Offset",newOff);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_HighVoltage
}
//--------------------------------------------------------
/**
 *	Read attribute LowVoltage related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_LowVoltage(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_LowVoltage(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_LowVoltage) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_LowVoltage_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_LowVoltage
}
//--------------------------------------------------------
/**
 *	Write attribute LowVoltage related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_LowVoltage(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_LowVoltage(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_LowVoltage) ENABLED START -----*/

	double newAmp;
	double newOff;

	if( !scpi->SetLowVoltage(w_val,&newAmp,&newOff) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_LowVoltage");	
	}
	lastUpdate=0;
	
	update_attr("Amplitude",newAmp);
	update_attr("Offset",newOff);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_LowVoltage
}
//--------------------------------------------------------
/**
 *	Read attribute Configuration_File related method
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_Configuration_File(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_Configuration_File(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_Configuration_File) ENABLED START -----*/

	attr_Configuration_File_read[0] = config_file;
	//	Set the attribute value
	attr.set_value(attr_Configuration_File_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_Configuration_File
}
//--------------------------------------------------------
/**
 *	Read attribute Function related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_Function(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_Function(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_Function) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Function_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_Function
}
//--------------------------------------------------------
/**
 *	Write attribute Function related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_Function(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_Function(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_Function) ENABLED START -----*/
	
	if( !scpi->SetFunc(w_val) ) {
      		Tango::Except::throw_exception(
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_Function");	
	}
	lastUpdate=0;
		
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_Function
}
//--------------------------------------------------------
/**
 *	Read attribute Frequency related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_Frequency(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_Frequency(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_Frequency) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Frequency_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_Frequency
}
//--------------------------------------------------------
/**
 *	Write attribute Frequency related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_Frequency(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_Frequency(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_Frequency) ENABLED START -----*/
	
	if( !scpi->SetFreq(w_val) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::write_Frequency");	
	}
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_Frequency
}
//--------------------------------------------------------
/**
 *	Read attribute NoiseBandwidth related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_NoiseBandwidth(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_NoiseBandwidth(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_NoiseBandwidth) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_NoiseBandwidth_read);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_NoiseBandwidth
}
//--------------------------------------------------------
/**
 *	Write attribute NoiseBandwidth related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_NoiseBandwidth(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_NoiseBandwidth(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_NoiseBandwidth) ENABLED START -----*/
	if( !scpi->SetNoiseBandwidth(w_val) ) {
		Tango::Except::throw_exception(
						(const char *)"Agilent33500B::error_write",
						(const char *)scpi->GetLastError().c_str(),
						(const char *)"Agilent33500B::write_NoiseBandwidth");
	}
	lastUpdate=0;

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_NoiseBandwidth
}
//--------------------------------------------------------
/**
 *	Read attribute OutputMode related method
 *	Description: 0=> Normal
 *               1=> Gated (output activated by an external input)
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_OutputMode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_OutputMode(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_OutputMode) ENABLED START -----*/
  if( attr_OutputMode_read[0]<0 )
    attr.set_quality(Tango::ATTR_INVALID);
  else
    attr.set_value(attr_OutputMode_read);

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_OutputMode
}
//--------------------------------------------------------
/**
 *	Write attribute OutputMode related method
 *	Description: 0=> Normal
 *               1=> Gated (output activated by an external input)
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_OutputMode(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_OutputMode(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_OutputMode) ENABLED START -----*/

  if( !scpi->SetOutputMode(w_val) ) {
    Tango::Except::throw_exception(
            (const char *)"Agilent33500B::error_write",
            (const char *)scpi->GetLastError().c_str(),
            (const char *)"Agilent33500B::write_OutputMode");
  }
  lastUpdate=0;

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_OutputMode
}
//--------------------------------------------------------
/**
 *	Read attribute WaveformFilter related method
 *	Description: 0=>Normal
 *               1=>Step
 *               2=>OFF
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::read_WaveformFilter(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_WaveformFilter(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_WaveformFilter) ENABLED START -----*/
	//	Set the attribute value
  if( attr_WaveformFilter_read[0]<0 )
    attr.set_quality(Tango::ATTR_INVALID);
  else
    attr.set_value(attr_WaveformFilter_read);

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_WaveformFilter
}
//--------------------------------------------------------
/**
 *	Write attribute WaveformFilter related method
 *	Description: 0=>Normal
 *               1=>Step
 *               2=>OFF
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent33500B::write_WaveformFilter(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_WaveformFilter(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_WaveformFilter) ENABLED START -----*/

  if( !scpi->SetWaveformFilter(w_val) ) {
    Tango::Except::throw_exception(
            (const char *)"Agilent33500B::error_write",
            (const char *)scpi->GetLastError().c_str(),
            (const char *)"Agilent33500B::write_WaveformFilter");
  }
  lastUpdate=0;

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_WaveformFilter
}
//--------------------------------------------------------
/**
 *	Read attribute Waveform related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 16000000
 */
//--------------------------------------------------------
void Agilent33500B::read_Waveform(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::read_Waveform(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::read_Waveform) ENABLED START -----*/

	// TO BE IMPLEMENTED
	// See Scpi::ReadWaveForm()
	
	//int lgth;
	//if( !scpi->ReadWaveForm(&lgth,attr_Waveform_read) ) {
      	//      Tango::Except::throw_exception(         
        //	(const char *)"Agilent33500B::error_read",
        //	(const char *)scpi->GetLastError().c_str(),
        //	(const char *)"Agilent33500B::read_Waveform");	
	//}
	
	attr.set_value(attr_Waveform_read, waveFormLgth);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::read_Waveform
}
//--------------------------------------------------------
/**
 *	Write attribute Waveform related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 16000000
 */
//--------------------------------------------------------
void Agilent33500B::write_Waveform(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent33500B::write_Waveform(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve number of write values
	int	w_length = attr.get_write_value_length();

	//	Retrieve pointer on write values (Do not delete !)
	const Tango::DevDouble	*w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent33500B::write_Waveform) ENABLED START -----*/

	sequence_running = LOAD_WAVEFORM;
	set_state(Tango::MOVING);
	sequence_error = "";

	waveFormLgth = w_length;
	for(int i=0;i<waveFormLgth;i++) attr_Waveform_read[i]=w_val[i];

	// Launch loading thread
	LoadThread *lt = new LoadThread(this,mutex);

	// Save waveform to a file
  save_waveform(attr_Waveform_read,waveFormLgth);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::write_Waveform
}

//--------------------------------------------------------
/**
 *	Method     : Agilent33500B::add_dynamic_attributes()
 *	Description: Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Agilent33500B::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Agilent33500B::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command State related method
 *	Description: This command gets the device state (stored in its device_state data member) and returns it to the caller.
 *
 *	@returns Device state
 */
//--------------------------------------------------------
Tango::DevState Agilent33500B::dev_state()
{
	DEBUG_STREAM << "Agilent33500B::State()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::dev_state) ENABLED START -----*/
	
	Tango::DevState	argout = Tango::UNKNOWN;

	if(iPAddress.empty())
	{
		set_state(Tango::FAULT);
		set_status("IPAdress property is not defined.");
		return get_state();
	}

	if(!scpi)
	{
		set_state(Tango::FAULT);
		set_status("Connection problem occurs.");
		return get_state();
	}

	if( scpi->is_connected() )
	{
		set_state(Tango::FAULT);
		set_status("No connection built.");
		return get_state();
	}

	if( sequence_running!=0 ) {

		set_state(Tango::MOVING);
    switch (sequence_running) {
      case LOAD_WAVEFORM:
        set_status("Downloading waveform");
        break;
      case LOAD_CONFIG:
        set_status("Loading configuration");
        break;

    }
		return get_state();

	}

	int state;

#ifdef  USE_YAT4TANGO
  attr_Amplitude_read[0] 			= yat::IEEE_NAN;
	attr_Offset_read[0] 				= yat::IEEE_NAN;
	attr_SampleRate_read[0] 		= yat::IEEE_NAN;
	attr_Delay_read[0]					= yat::IEEE_NAN;
	attr_Impedance_read[0] 			= yat::IEEE_NAN;
	attr_HighVoltage_read[0] 		= yat::IEEE_NAN;
	attr_LowVoltage_read[0] 		= yat::IEEE_NAN;
	attr_Frequency_read[0]			= yat::IEEE_NAN;
	attr_NoiseBandwidth_read[0]	= yat::IEEE_NAN;
#else
  attr_Amplitude_read[0] 			= NAN;
  attr_Offset_read[0] 				= NAN;
  attr_SampleRate_read[0] 		= NAN;
  attr_Delay_read[0]					= NAN;
  attr_Impedance_read[0] 			= NAN;
  attr_HighVoltage_read[0] 		= NAN;
  attr_LowVoltage_read[0] 		= NAN;
  attr_Frequency_read[0]			= NAN;
  attr_NoiseBandwidth_read[0]	= NAN;
#endif

  attr_TriggerMode_read[0]		= -1;
  attr_Triggering_read[0] 		= -1;
  attr_BurstState_read[0] 		= -1;
  attr_BurstMode_read[0] 			= -1;
  attr_TrackMode_read[0] 			= -1;
  attr_BurstCycle_read[0] 		= -1;
  attr_OutputMode_read[0] 		= -1;
  attr_WaveformFilter_read[0] = -1;
  attr_Function_read[0]				= -1;

	if( !scpi->GetAll(&state,
          attr_Amplitude_read,
		 	    attr_Offset_read,
			    attr_SampleRate_read,
			    attr_TriggerMode_read,
			    attr_Triggering_read,
			    attr_Delay_read,
			    attr_BurstState_read,
			    attr_BurstMode_read,
			    attr_TrackMode_read,
			    attr_Impedance_read,
			    attr_BurstCycle_read,
			    attr_HighVoltage_read,
			    attr_LowVoltage_read,
			    attr_Function_read,
			    attr_Frequency_read,
					attr_NoiseBandwidth_read,
          attr_OutputMode_read,
          attr_WaveformFilter_read
			    ) ) {

	  set_state(Tango::ALARM);
	  set_status(scpi->GetLastError());
	  return get_state();

	}

	// Update state and status
	if( state ) {
	  set_state(Tango::ON);
	  set_status("Output is ON\n"+sequence_error);
	} else {
	  set_state(Tango::OFF);
	  set_status("Output is OFF\n"+sequence_error);
	}

  argout = get_state();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::dev_state
	set_state(argout);    // Give the state to Tango.
	if (argout!=Tango::ALARM)
		Tango::DeviceImpl::dev_state();
	return get_state();  // Return it after Tango management.
}
//--------------------------------------------------------
/**
 *	Command Reset related method
 *	Description: Reset the generator
 *
 */
//--------------------------------------------------------
void Agilent33500B::reset()
{
	DEBUG_STREAM << "Agilent33500B::Reset()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::reset) ENABLED START -----*/
	
	if( !scpi->Reset() ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::reset");	
	}

  sequence_error = "";
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::reset
}
//--------------------------------------------------------
/**
 *	Command On related method
 *	Description: Switch ON the output
 *
 */
//--------------------------------------------------------
void Agilent33500B::on()
{
	DEBUG_STREAM << "Agilent33500B::On()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::on) ENABLED START -----*/
	
	if( !scpi->SetOutput(1) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::on");	
	}
	
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::on
}
//--------------------------------------------------------
/**
 *	Command Off related method
 *	Description: Switch off the output
 *
 */
//--------------------------------------------------------
void Agilent33500B::off()
{
	DEBUG_STREAM << "Agilent33500B::Off()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::off) ENABLED START -----*/
	
	if( !scpi->SetOutput(0) ) {
      		Tango::Except::throw_exception(         
        	(const char *)"Agilent33500B::error_write",
        	(const char *)scpi->GetLastError().c_str(),
        	(const char *)"Agilent33500B::off");	
	}
	
	lastUpdate=0;
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::off
}
//--------------------------------------------------------
/**
 *	Command LoadConfigurationFile related method
 *	Description: Loads a configuration file
 *
 *	@param argin Configuration file name (without the path)
 */
//--------------------------------------------------------
void Agilent33500B::load_configuration_file(Tango::DevString argin)
{
	DEBUG_STREAM << "Agilent33500B::LoadConfigurationFile()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::load_configuration_file) ENABLED START -----*/
	
	sprintf(full_file_name,"%s/%s",configFilePath.c_str(),argin);
	strcpy(config_file,argin);
  sequence_running = LOAD_CONFIG;
  set_state(Tango::MOVING);
  sequence_error = "";
  new LoadThread(this,mutex);

	// Save config file name in DB
	Tango::DbData db_data;
	Tango::DbDatum cfg_file("ConfigFile");
	cfg_file << argin;
  db_data.push_back(cfg_file);
	get_db_device()->put_property(db_data);
	strcpy(config_file,argin);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::load_configuration_file
}
//--------------------------------------------------------
/**
 *	Command SaveConfigurationFile related method
 *	Description: Save a configuration file
 *
 *	@param argin Configuration file name (without the path)
 */
//--------------------------------------------------------
void Agilent33500B::save_configuration_file(Tango::DevString argin)
{
	DEBUG_STREAM << "Agilent33500B::SaveConfigurationFile()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::save_configuration_file) ENABLED START -----*/
	
	char full_file_name[512];
	sprintf(full_file_name,"%s/%s",configFilePath.c_str(),argin);	
        ofstream conf(full_file_name, ios::out);
        strcpy(config_file,argin);

        if (conf.is_open()) {
	
            conf << "## Agilent W33500B aveform generator  CONFIG  FILE ##" << endl;
  	        conf << "Impedance\t" << get_write_value_double("Impedance") << endl;
            conf << "Amplitude\t" <<  get_write_value_double("Amplitude") << endl;
            conf << "Offset\t" << get_write_value_double("Offset") << endl;
            conf << "SampleRate\t" << get_write_value_double("SampleRate") << endl;
            conf << "TriggerMode\t" << get_write_value_short("TriggerMode") << endl;
            conf << "Triggering\t" << get_write_value_short("Triggering") << endl;
            conf << "Delay\t" << get_write_value_double("Delay") << endl;
            conf << "TrackMode\t" << get_write_value_short("TrackMode") << endl;
            conf << "BurstMode\t" << get_write_value_short("BurstMode") << endl;
            conf << "BurstCycle\t" << get_write_value_short("BurstCycle") << endl;
            conf << "BurstState\t" << get_write_value_short("BurstState") << endl;
            conf << "Function\t" << get_write_value_short("Function") << endl;
  					conf << "Frequency\t" << get_write_value_double("Frequency") << endl;
            conf << "NoiseBandwidth\t" << get_write_value_double("NoiseBandwidth") << endl;
            conf << "OutputMode\t" << get_write_value_short("OutputMode") << endl;
            conf << "WaveformFilter\t" << get_write_value_short("WaveformFilter") << endl;

	    // Save the waveform.
            conf << "Waveform:          " <<  waveFormLgth << endl;

            for (int i=0; i < waveFormLgth; i++)
            {
              conf << setprecision(10)<< attr_Waveform_read[i] << endl;
            }
            conf.close();
	  
        } else {
	
	    char errStr[1024];
	    sprintf(errStr,"Failed to open the file %s: %s",full_file_name,strerror(errno));
	
	    // Unable to create file for save.
            Tango::Except::throw_exception(
                (const char*)"Agilent33500B::error_write",
                (const char*)errStr,
                (const char*)"Agilent33500B::save_configuration_file()",
                Tango::ERR );
        
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::save_configuration_file
}
//--------------------------------------------------------
/**
 *	Command GetConfigurationFilePath related method
 *	Description: Returns the absolute confiration file path
 *
 *	@returns Configuration file path
 */
//--------------------------------------------------------
Tango::DevString Agilent33500B::get_configuration_file_path()
{
	Tango::DevString argout;
	DEBUG_STREAM << "Agilent33500B::GetConfigurationFilePath()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::get_configuration_file_path) ENABLED START -----*/
	
	argout  = new char[configFilePath.length()+1];
	strcpy(argout, configFilePath.c_str());
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::get_configuration_file_path
	return argout;
}
//--------------------------------------------------------
/**
 *	Command SaveToFlash related method
 *	Description: Save device configuration flash memory (block 0 used when booting)
 *
 */
//--------------------------------------------------------
void Agilent33500B::save_to_flash()
{
	DEBUG_STREAM << "Agilent33500B::SaveToFlash()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::save_to_flash) ENABLED START -----*/
	
  if( !scpi->SendSAV0() ) {
    Tango::Except::throw_exception(
            (const char *)"Agilent33500B::error_write",
            (const char *)scpi->GetLastError().c_str(),
            (const char *)"Agilent33500B::save_to_flash");
  }

	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::save_to_flash
}
//--------------------------------------------------------
/**
 *	Command ReLoadConfigurationFile related method
 *	Description: Reloads the currently loaded configuration file.
 *               If no file has been previouly loaded, it does nothing.
 *
 */
//--------------------------------------------------------
void Agilent33500B::re_load_configuration_file()
{
	DEBUG_STREAM << "Agilent33500B::ReLoadConfigurationFile()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Agilent33500B::re_load_configuration_file) ENABLED START -----*/
  if(strlen(config_file)>0)
    load_configuration_file(config_file);
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::re_load_configuration_file
}
//--------------------------------------------------------
/**
 *	Method     : Agilent33500B::add_dynamic_commands()
 *	Description: Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Agilent33500B::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Agilent33500B::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500B::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Agilent33500B::namespace_ending) ENABLED START -----*/

//	Additional Methods

void Agilent33500B::reload_waveform() {

  // Read waveform from a file
  FILE *f = fopen(waveformFile.c_str(), "r");
  if (f != NULL) {

    char *line = NULL;
    while (!feof(f)) {
      size_t nbRead = 0;
      if (getline(&line, &nbRead, f) != -1) {
        if (line && nbRead > 0) {
          attr_Waveform_read[waveFormLgth] = atof(line);
          waveFormLgth++;
        }
      }
    }
    if (line) free(line);
    fclose(f);

    if (!scpi->LoadWaveForm(waveFormLgth, attr_Waveform_read)) {
      Tango::Except::throw_exception(
              (const char *) "Agilent33500B::error_write",
              (const char *) scpi->GetLastError().c_str(),
              (const char *) "Agilent33500B::reload_waveform");
    }

  }


}

string Agilent33500B::get_write_value_from_db(string attName) {

  // Read conversion factors
  string ret = "0";

  Tango::DbData db_data;
  db_data.push_back(Tango::DbDatum(attName));
  get_db_device()->get_attribute_property(db_data);
  //cout << "db_data.size=" << db_data.size() << endl;

  for (int i=0;i < (int)db_data.size();i++)
  {

    Tango::DevLong nb_prop;
    double a;
    //cout << "db_data.name=" << db_data[i].name << endl;
    db_data[i] >> nb_prop;
    i++;
    for(int k=0;k < nb_prop;k++)
    {
      if( strcasecmp(db_data[i].name.c_str(),"__value")==0 ) {
        db_data[i] >> ret;
      }
      i++;
    }

  }

  return ret;

}

void Agilent33500B::update_attr(string att_name,double value) {

  // Udpate write value for a memorized attribute
  
  Tango::WAttribute &att = dev_attr->get_w_attr_by_name(att_name.c_str());
  att.set_write_value(value);

  Tango::Util *tg = Tango::Util::instance();
  Tango::Database *db = tg->get_database();		
  Tango::DbDatum Attr(att_name);
  Tango::DbDatum Value("__value");
  Attr << (short)1;
  Value << value;
  Tango::DbData db_val;
  db_val.push_back(Attr);
  db_val.push_back(Value);
  tg->get_database()->put_device_attribute_property(get_name(), db_val);	

}

void Agilent33500B::update_attr(string att_name,short value) {

  // Udpate write value for a memorized attribute

  Tango::WAttribute &att = dev_attr->get_w_attr_by_name(att_name.c_str());
  att.set_write_value(value);

  Tango::Util *tg = Tango::Util::instance();
  Tango::Database *db = tg->get_database();
  Tango::DbDatum Attr(att_name);
  Tango::DbDatum Value("__value");
  Attr << (short)1;
  Value << value;
  Tango::DbData db_val;
  db_val.push_back(Attr);
  db_val.push_back(Value);
  tg->get_database()->put_device_attribute_property(get_name(), db_val);

}

double Agilent33500B::get_write_value_double(string att_name) {

  Tango::DevDouble retValue;
  Tango::WAttribute &att = dev_attr->get_w_attr_by_name(att_name.c_str());
  att.get_write_value(retValue);
  return retValue;

}

short Agilent33500B::get_write_value_short(string att_name) {

  Tango::DevShort retValue;
  Tango::WAttribute &att = dev_attr->get_w_attr_by_name(att_name.c_str());
  att.get_write_value(retValue);
  return retValue;

}

void Agilent33500B::set_wvalue(string name,double value) {
  Tango::WAttribute &att = dev_attr->get_w_attr_by_name(name.c_str());
  att.set_write_value(value);
  update_attr(name,value);
}

void Agilent33500B::set_wvalue(string name,short value) {
  Tango::WAttribute &att = dev_attr->get_w_attr_by_name(name.c_str());
  att.set_write_value(value);
  update_attr(name,value);
}

void Agilent33500B::load_configuration() {

  int lgth = 0;

  // Default values
  double impedance = 50.0;
  double amplitude = 10.0;
  double offset = 0.0;
  double sample_rate = 40000.0;
  double delay = 0.0;
  short trigger_mode = 0;
  short tiggering = 0;
  short track_mode = 1;
  short burst_mode = 0;
  short burst_cycle = 1;
  short busrt_state = 0;
  short func = FUNC_ARB;
  double freq = 1000.0;
	double noiseBandwidth = 1e5;
  short output_mode = 0;
  short waveform_filter = 0;
  double *wave = NULL;

  // Parse file		    
  ifstream conf(full_file_name, ios::in);
  stringstream ss;

  if (conf.is_open()) {

    string att_name("");
    while (!conf.eof()) {

      char buffer[512];

      // Read a line from file.
      conf.getline(buffer, 512);
      string rd = string(buffer);

      if (rd.length() == 0) {
        // End of file reached
        continue;
      }

      if (rd[0] == '#') {

        // it is a comment line, skip it!
        continue;

      } else if (rd.find("Waveform:") == string::npos) {

        // it is not the waveform so we assume it is an attribute name
        ss.clear();
        ss.str(rd);
        ss >> att_name;

        if (att_name == "Impedance") {

          ss >> impedance;
          cout << "Impendance =" << impedance << endl;

        } else if (att_name == "Amplitude") {

          ss >> amplitude;
          cout << "Amplitude =" << amplitude << endl;

        } else if (att_name == "Offset") {

          ss >> offset;
          cout << "Offset =" << offset << endl;

        } else if (att_name == "SampleRate") {

          ss >> sample_rate;
          cout << "SampleRate =" << sample_rate << endl;

        } else if (att_name == "Delay") {

          ss >> delay;
          cout << "Delay =" << delay << endl;

        } else if (att_name == "TriggerMode") {

          ss >> trigger_mode;
          cout << "TriggerMode =" << trigger_mode << endl;

        } else if (att_name == "Triggering") {

          ss >> tiggering;
          cout << "Triggering =" << tiggering << endl;

        } else if (att_name == "TrackMode") {

          ss >> track_mode;
          cout << "TrackMode =" << track_mode << endl;

        } else if (att_name == "BurstMode") {

          ss >> burst_mode;
          cout << "BurstMode =" << burst_mode << endl;

        } else if (att_name == "BurstCycle") {

          ss >> burst_cycle;
          cout << "BurstCycle =" << burst_cycle << endl;

        } else if (att_name == "BurstState") {

          ss >> busrt_state;
          cout << "BurstState =" << busrt_state << endl;

        } else if (att_name == "Frequency") {

          ss >> freq;
          if (freq <= 0.0) freq = 1000.0; // Wrok around wrong config file
          cout << "Frequency =" << freq << endl;

        } else if (att_name == "NoiseBandwidth") {

					ss >> noiseBandwidth;
					cout << "NoiseBandwidth =" << noiseBandwidth << endl;

				} else if (att_name == "OutputMode") {

          ss >> output_mode;
          cout << "OutputMode =" << output_mode << endl;

        } else if (att_name == "WaveformFilter") {

          ss >> waveform_filter;
          cout << "WaveformFilter =" << waveform_filter << endl;

        } else if (att_name == "Function") {

          ss >> func;
          cout << "Func =" << func << endl;

        }

      } else {

        //Found 'Waveform:' label. Waveform curve lies below.
        rd = rd.substr(9);
        ss.clear();
        ss.str(rd);

        // Avoid waveform overflow
        if (lgth > 16000000)
          lgth = 16000000;

        if (lgth < 0)
          lgth = 0;

        // reference_curve_length is the expected number of values.
        ss >> lgth;

        if(lgth>0)
          wave = (double *) malloc(lgth * sizeof(double));

        // Now load waveform values.
        int ind = 0;
        while ((ind < lgth) && (!conf.eof())) {
          double dd;
          conf.getline(buffer, 512);
          // Skip empty lines
          if (!rd.empty()) {
            rd = string(buffer);
            ss.clear();
            ss.str(rd);
            ss >> dd;
            wave[ind] = dd;
            ind++;
          }
        }

        // Have we got a full waveform ?
        if ((ind != lgth) || conf.eof()) {
          // Some data are probably missing in ReferenceCurve !
          Tango::Except::throw_exception(
                  (const char *) "Agilent33500B::error_write",
                  (const char *) "Some data are missing in waveform",
                  (const char *) "Agilent33500B::LoadConfiguration");
        }

        cout << "Waveform: Got " << ind << " points" << endl;

      } // End waveform Loading routine.

    } // End of while()

  } else {

    // Unable to open configuration file.
    char errStr[1024];
    sprintf(errStr, "Failed to open the file: %s", strerror(errno));

    Tango::Except::throw_exception(
            (const char *) "Agilent33500B::error_write",
            (const char *) errStr,
            (const char *) "Agilent33500B::LoadConfiguration");


  }

  cout << "End of parsing" << endl;

  // Update write value field
  set_wvalue("Impedance", impedance);
  set_wvalue("Amplitude", amplitude);
  set_wvalue("Offset", offset);
  set_wvalue("SampleRate", sample_rate);
  set_wvalue("Delay", delay);
  set_wvalue("TriggerMode", trigger_mode);
  set_wvalue("Triggering", tiggering);
  set_wvalue("TrackMode", track_mode);
  set_wvalue("BurstMode", burst_mode);
  set_wvalue("BurstCycle", burst_cycle);
  set_wvalue("BurstMode", burst_mode);
  set_wvalue("BurstState", busrt_state);
  set_wvalue("Function", func);
  set_wvalue("Frequency", freq);
	set_wvalue("NoiseBandwidth", noiseBandwidth);
  set_wvalue("OutputMode", output_mode);
  set_wvalue("WaveformFilter", waveform_filter);

  // Upload parameters
  if (!scpi->SetAll(
          impedance,
          amplitude,
          offset,
          sample_rate,
          trigger_mode,
          tiggering,
          delay,
          track_mode,
          burst_mode,
          burst_cycle,
          busrt_state,
          func,
          freq,
					noiseBandwidth,
          output_mode,
          waveform_filter,
          lgth,
          wave)) {

    conf.close();
    Tango::Except::throw_exception(
            (const char *) "Agilent33500B::error_write",
            (const char *) scpi->GetLastError().c_str(),
            (const char *) "Agilent33500B::LoadConfiguration");

  }

  waveFormLgth = lgth;
  for (int i = 0; i < waveFormLgth; i++) attr_Waveform_read[i] = wave[i];
  save_waveform(wave, lgth);
  if(wave) free(wave);

  // Loading successfull !
  conf.close();

}

void Agilent33500B::save_waveform(double *wave,int nb) {

  // Save waveform to a file
  FILE *f = fopen(waveformFile.c_str(),"w");
  if( f!=NULL ) {
    for(int i=0;i<nb;i++)
      fprintf(f,"%.6f\n",wave[i]);
    fclose(f);
  }	

}

/*----- PROTECTED REGION END -----*/	//	Agilent33500B::namespace_ending
} //	namespace
